package
{
	import be.aboutme.differenceKey.DifferenceImage;
	
	import com.bit101.components.CheckBox;
	import com.bit101.components.HSlider;
	import com.bit101.components.Label;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.GlowFilter;
	import flash.media.Camera;
	import flash.media.Video;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.Timer;

	[SWF(backgroundColor="#000000")]
	public class KeyingDemo extends Sprite
	{
		
		private var video:Video;
		private var differenceImage:DifferenceImage;
		private var preBlurSlider:HSlider;
		private var postBlurSlider:HSlider;
		private var tolerance1Slider:HSlider;
		private var tolerance2Slider:HSlider;
		private var tolerance3Slider:HSlider;
		private var hsbCheckbox:CheckBox;
		private var instructionsField:TextField;
		private var countDownField:TextField;
		private var background:Sprite;
		
		private var fontContainer:FontContainer;
		
		public function KeyingDemo()
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			background = new Background();
			addChild(background);
			
			instructionsField = new TextField();
			instructionsField.x = 650;
			instructionsField.width = 300;
			instructionsField.multiline = true;
			instructionsField.autoSize = TextFieldAutoSize.LEFT;
			instructionsField.defaultTextFormat = new TextFormat("Helvetica", 18, 0xFFFFFF, null, null, null, null, null, null, null, null, null, 10);
			instructionsField.htmlText = "1. Allow webcam access<br />2. Click the image and step out of the frame<br />3. Adjust the settings below to get better results";
			addChild(instructionsField);
			
			var camera:Camera = Camera.getCamera();
			
			if(camera)
			{
				camera.setMode(640, 480, 25);
				video = new Video(640, 480);
				video.attachCamera(camera);
				
				differenceImage = new DifferenceImage();
				differenceImage.foreground = video;
				addChild(differenceImage);
				
				var settingsContainer:Sprite = new Sprite();
				settingsContainer.x = 650;
				settingsContainer.y = 100;
				addChild(settingsContainer);
				
				preBlurSlider = new HSlider(settingsContainer, 0, 5, preBlurChangeHandler);
				preBlurSlider.maximum = 50;
				preBlurSlider.value = differenceImage.preBlur;
				new Label(settingsContainer, 105, 0, "Pre Blur");
				
				postBlurSlider = new HSlider(settingsContainer, 0, 25, postBlurChangeHandler);
				postBlurSlider.maximum = 50;
				postBlurSlider.value = differenceImage.postBlur;
				new Label(settingsContainer, 105, 20, "Post Blur");
				
				tolerance1Slider = new HSlider(settingsContainer, 0, 45, toleranceChangeHandler);
				tolerance1Slider.maximum = 1;
				tolerance1Slider.value = differenceImage.tolerance1;
				new Label(settingsContainer, 105, 40, "Tolerance 1");
				
				tolerance2Slider = new HSlider(settingsContainer, 0, 65, toleranceChangeHandler);
				tolerance2Slider.maximum = 1;
				tolerance2Slider.value = differenceImage.tolerance2;
				new Label(settingsContainer, 105, 60, "Tolerance 2");
				
				tolerance3Slider = new HSlider(settingsContainer, 0, 85, toleranceChangeHandler);
				tolerance3Slider.maximum = 1;
				tolerance3Slider.value = differenceImage.tolerance3;
				new Label(settingsContainer, 105, 80, "Tolerance 3");
				
				hsbCheckbox = new CheckBox(settingsContainer, 0, 105, "HSB Mode", hsbChangeHandler);
				
				differenceImage.addEventListener(MouseEvent.CLICK, snapBackground);
			}
			
			countDownField = new TextField();
			countDownField.filters = [new GlowFilter(0x000000)];
			countDownField.defaultTextFormat = new TextFormat("Helvetica", 128, 0xFFFFFF, true, null, null, null, null, "center");
			countDownField.embedFonts = true;
			countDownField.selectable = false;
			countDownField.width = 640;
			countDownField.y = 200;
			countDownField.mouseEnabled = false;
			addChild(countDownField);
		}
		
		private function preBlurChangeHandler(event:Event):void
		{
			differenceImage.preBlur = preBlurSlider.value;
		}
		
		private function postBlurChangeHandler(event:Event):void
		{
			differenceImage.postBlur = postBlurSlider.value;
		}
		
		private function toleranceChangeHandler(event:Event):void
		{
			differenceImage.tolerance1 = tolerance1Slider.value;
			differenceImage.tolerance2 = tolerance2Slider.value;
			differenceImage.tolerance3 = tolerance3Slider.value;
		}
		
		private function hsbChangeHandler(event:Event):void
		{
			differenceImage.mode = (hsbCheckbox.selected) ? 1 : 0;
		}
		
		private function snapBackground(event:Event):void
		{
			countDownField.text = "3";
			var countDownTimer:Timer = new Timer(1000, 3);
			countDownTimer.addEventListener(TimerEvent.TIMER, function(event:TimerEvent):void
			{
				countDownField.text = "" + (3 - countDownTimer.currentCount);
			});
			countDownTimer.addEventListener(TimerEvent.TIMER_COMPLETE, function(event:TimerEvent):void
			{
				countDownField.text = "";
				differenceImage.background = video;
			});
			countDownTimer.start();
		}
		
	}
}